$regfile = "attiny2313.dat"
$crystal = 1000000


Dim W As Byte                                               '    
Const Pult = 1                                              ' ,      

'
Config Portb.0 = Input
Config Portb.1 = Input
Config Portb.2 = Input
Config Portd.6 = Input

Config Portd.5 = Output                                     '   
Portd.5 = 0
Led Alias Portd.5

Config Int0 = Falling                                       '   
On Int0 Button
Enable Interrupts                                           ' 
Enable Int0


Config Portd.0 = Output                                     '       
Portd.0 = 0

' 
Declare Sub W_register(byval C_bytes As Byte)
'SPI (nRF24L01) 
Const Write_reg = &H20                                      '    
Const Wr_tx_pload = &HA0                                    ' Tx    
Const Flush_tx = &HE1                                       '  Tx  
'SPI (nRF24L01)  ()
Const Config_nrf = &H00                                     'Config  
Const En_aa = &H01                                          '    
Const En_rxaddr = &H02                                      ' Rx  "  "
Const Rf_ch = &H05                                          'RF channel'  
Const Rf_setup = &H06                                       ' Setup " ()  "
Const Status = &H07                                         ' "  "
Const Rx_addr_p0 = &H0A                                     'rx  Pipe0 "  "
Const Tx_addr = &H10                                        'TX address ()
Dim D_bytes(6) As Byte
' 
Config Spi = Soft , Din = Portb.6 , Dout = Portb.5 , Ss = Portb.3 , Clock = Portb.7
'  SPI 
Config Portb.4 = Output : Ce Alias Portb.4                  'CE pin is output
Config Portb.3 = Output : Ss Alias Portb.3                  'SS pin is output
Config Pind.4 = Input : Irq Alias Pind.4                    'IRQ pin is input

Spiinit



Portd.5 = 1
Waitms 10
Portd.5 = 0

'  
Do
Portd.0 = 1                                                 ' 
Waitms 10
Gosub Peredacha                                             ' 
Portd.0 = 0                                                 ' 
W = 0

Idle                                                        ' 

Loop

End



' 
Button:
'       
Do
Waitms 100
Dim B As Byte
 If Pinb.2 = 0 Then
  W = 1
 End If

 If Pinb.1 = 0 Then
  W = 2
 End If

 If Pinb.0 = 0 Then
  W = 3
 End If

 If Pind.6 = 0 Then
  W = 4
 End If

 If W <> 0 Then
Portd.5 = 1
Waitms 100
Portd.5 = 0
End If


Incr B

Loop Until W <> 0 Or B > 10                                 '     , 

Waitms 10
Gifr = 64                                                   '  

Return




'  
Peredacha:
Set Ce
Waitms 10
Reset Ce
Reset Ss

D_bytes(1) = Flush_tx                                       'Flush the TX_fifo 
Call W_register(1)
D_bytes(1) = Write_reg + Status                             'Reset IRQ 
D_bytes(2) = &B00110000
Call W_register(2)

Gosub Setup_tx                                              ' nrf240l01  TX
D_bytes(1) = Wr_tx_pload                                    ' 5   TX pload 
D_bytes(2) = W                                              ' 1    
D_bytes(3) = &H00                                           ' 2
D_bytes(4) = &H00                                           ' 3
D_bytes(5) = &H00                                           ' 4
D_bytes(6) = Pult                                           ' 5    
Call W_register(6)                                          ' 6   

Waitms 2
Set Ce                                                      'Set CE,    fifo
Waitms 1
Reset Ce

Return




'      
Sub W_register(byval C_bytes As Byte)                       '   SPI
Reset Ss                                                    '   ,     , 
Spiout D_bytes(1) , C_bytes                                 'Shiftout   SPI , C_bytes   ,   
Set Ss                                                      'Set  
End Sub

Setup_tx:                                                   '  TX
D_bytes(1) = Write_reg + Tx_addr                            'TX 
D_bytes(2) = &H34
D_bytes(3) = &H43
D_bytes(4) = &H10
D_bytes(5) = &H10
D_bytes(6) = &H01
Call W_register(6)
D_bytes(1) = Write_reg + Rx_addr_p0                         'RX   pipe0
D_bytes(2) = &H34
D_bytes(3) = &H43
D_bytes(4) = &H10
D_bytes(5) = &H10
D_bytes(6) = &H01
Call W_register(6)
D_bytes(1) = Write_reg + En_aa                              'Enable auto ACK  pipe0
D_bytes(2) = &H01
Call W_register(2)
D_bytes(1) = Write_reg + En_rxaddr                          ' RX   pipe0
D_bytes(2) = &H01
Call W_register(2)
D_bytes(1) = Write_reg + Rf_ch                              ' 
D_bytes(2) = 40                                             ' 2440 M
Call W_register(2)
D_bytes(1) = Write_reg + Rf_setup                           '  ->   0 , datarate 2  /  
D_bytes(2) = &H0F
Call W_register(2)
D_bytes(1) = Write_reg + Config_nrf                         ' CONFIG -> I=0 (TX_device), PWR_UP=1, CRC 2bytes,  CRC
D_bytes(2) = &H0E
Call W_register(2)
Return